// Copyright (c) 2003 Michael Rosellini. All rights reserved.
// See COPYING for terms of license.

#ifndef __termiohell_h
#define __termiohell_h

@class NSString;

// Open the TTY named by fn, setting the I/O baud rate to bps.  attrsOut
// must be non-null.  On return, *attrsOut will point to data about the
// device which should be passed to closeTty.  Throw exception e if this is
// not possible.
int openTty (NSString *fn, int bps, char **attrsOut, const NSString *e);

// Close the TTY and release the memory held by attrs.
void closeTty (int descriptor, char *attrs);

// Currently unused:
// Read up to len bytes from fd into b and return the number
// of bytes read.  Throw exception e if this is not possible.
int readFromTty (NSString *fn, int fd, char *b, int len, const NSString *e);

#endif
