#import <Foundation/Foundation.h>
#import <Plugins/Plugin.h>

@interface PluginManager : NSObject 
{
	NSMutableDictionary*     plugins;
    id<Plugin> selected;
}

+ (PluginManager*) defaultManager;

- (NSArray*) loadedPlugins;
- (NSArray*) loadedIdentifiers;

- (id<Plugin>) selectPlugin:(int) index;
- (id<Plugin>) selectedPlugin;

- (id<Plugin>) pluginWithIdentifier:(NSString*) ident;

- (void) loadPlugin:(NSString*) path;
- (void) unloadPlugin:(id<Plugin>) unload;

- (void) loadBuiltIns;
- (void) unloadPlugins;

/* NSOutlineViewDataSource Methods TODO move to iStumbler Window...

- (int)     outlineView:(NSOutlineView *) outlineView  
 numberOfChildrenOfItem:(id) item;

- (id)outlineView:(NSOutlineView*) outlineView 
            child:(int) index 
           ofItem:(id) item;

- (BOOL) outlineView:(NSOutlineView*) outlineView 
    isItemExpandable:(id) item;

- (id)        outlineView:(NSOutlineView *) outlineView
objectValueForTableColumn:(NSTableColumn *) tableColumn 
                   byItem:(id) item;

- (NSDragOperation) outlineView:(NSOutlineView*) outlineView
                   validateDrop:(id <NSDraggingInfo>) info
                   proposedItem:(id) item
             proposedChildIndex:(int) index;

- (BOOL) outlineView:(NSOutlineView*) outlineView
          acceptDrop:(id <NSDraggingInfo>) info
                item:(id) item
          childIndex:(int)index;

- (void) alertDidEnd:(NSAlert*) alert
          returnCode:(int) rc
         contextInfo:(void*) info;
*/

@end

/*  Copyright (c) 2005, Alf Watt (alf@istumbler.net). All rights reserved.
    Redistribution and use permitted under BSD-Style license.   */
